
%
%
%   UndStdLeakyMode
%   Understand leaky modes: Slab waveguide revisited
%
%   Copyright (2008)
%   Computational Photonics Laboratory
%   University of Maryland Baltimore County
%   
%   By Jonathan Hu
%

function MatrixSave=AbsorbingLayerapp(sPP,WPML,Points)



    baratio=5;
    [realne imagne] =WTypeLeaky(1.45,0.96*1.45,baratio,2*pi/1e-6,0);
    eff_nTarget=realne+i*imagne;

    tStart=clock;


    MaxLength=linspace(5,10,50)'*1e-6;% used for paper plot
    eff_n=zeros(size(MaxLength));
    PMLarray=zeros(size(MaxLength));

    v0Target =0;
    for ii=1:length(MaxLength)
        fprintf('Calculating point # %d/%d\n',ii,length(MaxLength));    

        fprintf('eff_nTarget=%f%e*i,length(v0Target)=%d,MaxLength=%f,Points=%d,\n WPML=%d,sPP=%f,baratio=%d\n', ...
            real(eff_nTarget),imag(eff_nTarget),length(v0Target),MaxLength(ii),Points,WPML,sPP,baratio);
        [eff_ntemp FieldBoundary v0]=AbsorbingLayerSolver(eff_nTarget,v0Target,MaxLength(ii),...
            10^5,WPML,sPP,baratio,1,0);
        [C I]=min(abs(imag(eff_ntemp)));
        eff_n(ii)=(eff_ntemp(I(1)));
        v0Target =v0;        
        PMLarray(ii)=WPML;
        runtime = etime(clock,tStart);
        fprintf('run time WTypeFDapp = %fs or %fm or %fh\n',runtime,runtime/60,runtime/3600);    
    end;
    MatrixSave=[MaxLength real(eff_n) imag(eff_n) PMLarray sPP*ones(size(MaxLength))];
    runtime = etime(clock,tStart);
    fprintf('run time WTypeFDapp = %fs or %fm or %fh\n',runtime,runtime/60,runtime/3600);    


    