%
%
%   UndStdLeakyMode
%   Understand leaky modes: Slab waveguide revisited
%
%   Copyright (2008)
%   Computational Photonics Laboratory
%   University of Maryland Baltimore County
%   
%   By Jonathan Hu
%
function [neffR neffI] = BandgapLeaky(na,n1,n2,t,pitch,N,wavenumber)
sq=inline('x.*x','x');
numlayer=N;
lambda=2*pi/wavenumber;

save data/lambda.dat lambda -ascii -tabs;
save data/pitch.dat pitch -ascii -tabs;
save data/n1.dat n1 -ascii -tabs;
save data/n2.dat n2 -ascii -tabs;
save data/na.dat na -ascii -tabs;
save data/t.dat t -ascii -tabs;
save data/numlayer.dat numlayer -ascii -tabs;






if (na<1.001)
    neff=1:-0.00001:0.8;
else if (na>2.8)
        neff=na:-0.00001:na-0.005;
    else        
        neff=na:-0.00001:1.20;
    end;
end;
neffbeta = neff(2:end-1)*wavenumber;
EqLeaky = abs(YehEqLeaky(neffbeta));
numneff = length(neffbeta);
numbermodes = 0;

for ii=2:1:numneff-1
    if(EqLeaky(ii)<EqLeaky(ii+1)&&EqLeaky(ii)<EqLeaky(ii-1)&&EqLeaky(ii)<1e9&&numbermodes<N)
        numbermodes=numbermodes+1;
        newx=(neffbeta(ii)+i*1e-6);
        x=newx*(1.01);
        IterationCount =0;
 %       fprintf('start %f +i%f \n',real(newx/wavenumber),imag(newx/wavenumber));
        while((abs(real(newx-x)/real(x))>1e-10|abs(imag(newx-x)/imag(x))>1e-5)&&IterationCount<200)
            x=newx;

            deltaR =  1e-9;
            F0=YehEqLeaky(x);
            F1=YehEqLeaky(real(x+deltaR)+i*imag(x));
            DifF = F1-F0;
            newx = x-(conj(DifF)/sq(abs(F1-F0))*deltaR*F0);
            fprintf('hu search at %.8f+i*%.10f correct =%.10f+i*%.10f EigenEq=%e\n',...
                real(newx)/wavenumber,imag(newx)/wavenumber,real((newx-x)/newx),imag((newx-x)/newx),abs(F1));
            IterationCount=IterationCount+1;
        end;
        neff = x/wavenumber; 
        neffR=real(neff);
        neffI=imag(neff);
    end; 
end;

