%
%
%   UndStdLeakyMode
%   Understand leaky modes: Slab waveguide revisited
%
%   Copyright (2008)
%   Computational Photonics Laboratory
%   University of Maryland Baltimore County
%   
%   By Jonathan Hu
%
function ei = Bandgapeigenequation(gamma,na,n1,n2,t,pitch,N,XLength,deltaX,wavenumber)

a=pitch/2;
b=pitch/2;

numlayer=N;

sq = inline('x.*x','x');


bWith=t/2+N*pitch;
load data/Endwithn1sign.dat;
if(Endwithn1sign==1)
    beta=sqrt(sq(wavenumber*n1)-sq(gamma));
else
    beta=sqrt(sq(wavenumber*n2)-sq(gamma));
end;

k1x=sqrt(sq(wavenumber*n1)-sq(beta));
k2x=sqrt(sq(wavenumber*n2)-sq(beta));
A=exp(-i*k1x*a).*(cos(k2x*b)-i/2*(k2x./k1x+k1x./k2x).*sin(k2x*b));
B=exp(i*k1x*a).*(-i/2*(k2x./k1x-k1x./k2x).*sin(k2x*b));
C=exp(-i*k1x*a).*(i/2*(k2x./k1x-k1x./k2x).*sin(k2x*b));
D=exp(i*k1x*a).*(cos(k2x*b)+i/2*(k2x./k1x+k1x./k2x).*sin(k2x*b));
K=1/pitch*acos(1/2*(A+D));
K = real(K)+i*abs(imag(K));

ka=sqrt(sq(wavenumber*na)-sq(beta));


% start to plot radiation mode
ei=zeros(length(gamma),1);
alpha=1;
a0=alpha/2*(cos(ka*t/2)+i*sin(ka*t/2).*ka./k1x);
b0=alpha/2*(cos(ka*t/2)-i*sin(ka*t/2).*ka./k1x);
an=(D.*YehUN(numlayer-1,K,pitch)-YehUN(numlayer-2,K,pitch)).*a0...
    -B.*YehUN(numlayer-1,K,pitch).*b0;
bn=-C.*YehUN(numlayer-1,K,pitch).*a0+(A.*YehUN(numlayer-1,K,pitch)...
    -YehUN(numlayer-2,K,pitch)).*b0;

    xN=N*pitch+deltaX:deltaX:XLength-t/2;


    if(Endwithn1sign==1)

        ei = real(i*k1x.*an.*exp(i*k1x*(XLength-N*pitch-t/2))...
            -i*k1x.*bn.*exp(-i*k1x*(XLength-N*pitch-t/2)));
    else
        det12 = (1+k2x./k1x).*(1+k2x./k1x)-(1-k2x./k1x).*(1-k2x./k1x);
        cn=((1+k2x./k1x).*an-(1-k2x./k1x).*bn)./det12;
        dn=(-1*(1-k2x./k1x).*an+(1+k2x./k1x).*bn)./det12;
        cn=cn./(2*abs(cn));
        dn=dn./(2*abs(dn));
        ei = real(i*k2x.*cn.*exp(i*k2x*(XLength-N*pitch-t/2))...
            -i*k2x.*dn.*exp(-i*k2x*(XLength-N*pitch-t/2)));
    end;


if(1>2)
plot(x/pitch, real(E)/max(real(E))); hold on;
plot([-t/pitch/2; -t/pitch/2],[1.5;-1.5],'r-.');
plot([t/pitch/2; t/pitch/2],[1.5;-1.5],'r-.');
plot([-(N*pitch + t/2)/pitch; -(N*pitch + t/2)/pitch],[1.5;-1.5],'r--');
plot([(N*pitch + t/2)/pitch; (N*pitch + t/2)/pitch],[1.5;-1.5],'r--');


Ce=1;
a0=Ce/2*(cos(ka*t/2)+i*sin(ka*t/2)./k1x);
b0=Ce/2*(cos(ka*t/2)-i*sin(ka*t/2)./k1x);
an=(D.*YehUN(numlayer-1,K,pitch)-YehUN(numlayer-2,K,pitch)).*a0-B.*YehUN(numlayer-1,K,pitch).*b0;
bn=-C.*YehUN(numlayer-1,K,pitch).*a0+(A.*YehUN(numlayer-1,K,pitch)-YehUN(numlayer-2,K,pitch)).*b0;
for ii=1:length(gamma)
    convert12 = [1+k2x(ii)./k1x(ii) 1-k2x(ii)./k1x(ii); 1-k2x(ii)./k1x(ii) 1+k2x(ii)./k1x(ii)]/2;
    abii=[an(ii);bn(ii)];
    cdii = inv(convert12)*abii;
    cn=cdii(1);dn=cdii(2);
end;
ei = [imag(cn.*exp(-i*k2x*(XLength-bWith))-dn.*exp(i*k2x*(XLength-bWith)))];
end;












