%
%
%   UndStdLeakyMode
%   Understand leaky modes: Slab waveguide revisited
%
%   Copyright (2008)
%   Computational Photonics Laboratory
%   University of Maryland Baltimore County
%   
%   By Jonathan Hu
%
function [outputrho outputnumSeries]= ThreeLayerGetRhoSet(n1,n2,a,XLength,k0,numSeries,plotsign)



omega=2*pi/2/XLength;
numB=numSeries*1000;

rho = linspace(omega/100,(numSeries+40)*omega,numB)';
eigenequation = ThreeLayerEigenequation(rho,n1,n2,k0,a,XLength);
if(plotsign==1)
	figure; plot(rho,eigenequation(:,2:3)); axis([min(rho),max(rho),-100, 100]);
	figure; plot(rho,eigenequation(:,1)); axis([min(rho),max(rho),-100, 100]);
end; 

StartIndex=2;
size(eigenequation);
bii=0;
outputrho = zeros(1,numSeries);

while (StartIndex<numB-10 && bii < numSeries) 
    bii = bii +1;
    while((eigenequation(StartIndex,1)*eigenequation(StartIndex+1,1)>0||...
		abs(eigenequation(StartIndex,1)-eigenequation(StartIndex+1,1))>...
		abs(eigenequation(StartIndex-1,1)-eigenequation(StartIndex+2,1)))&&...
        StartIndex<numB-2)
		StartIndex=StartIndex+1;
        
    end


	relTol = 0.00000001;	DerX = 1e-8;	changeX=1;	MaxIterNum=100;IterNum=0;
	StartX=(rho(StartIndex)+rho(StartIndex+1))/2;
	while(abs(changeX/StartX)>relTol&&IterNum<MaxIterNum)
		F0=ThreeLayerEigenequation(StartX,n1,n2,k0,a,XLength);F0 = F0(1);
		F1=ThreeLayerEigenequation(StartX*(1+DerX),n1,n2,k0,a,XLength);F1 = F1(1);
		changeX = F0/(F0-F1)*(StartX*DerX);
		StartX=StartX+changeX;
		IterNum=IterNum+1;
	end;
	outputrho(bii) =StartX;
	if(IterNum>MaxIterNum)	
		fprintf('exceed max Iternum\n'); stop;
	end;

	StartIndex=StartIndex+1;
end;
outputrho=outputrho(1:bii);
outputnumSeries=bii;
if(plotsign==1)
	figure; plot(1:numSeries,outputrho); %axis([min(rho),max(rho),-10, 10]);
end;
