%
%
%   UndStdLeakyMode
%   Understand leaky modes: Slab waveguide revisited
%
%   Copyright (2008)
%   Computational Photonics Laboratory
%   University of Maryland Baltimore County
%   
%   By Jonathan Hu
%

function outputGamma = WTypeGetgammaSet(n1,n2,a,b,XLength,wavenumber,numSeries,plotsign)


omega=2*pi/2/XLength;
numB=numSeries*1000;
%eigenequation=zeros(numB,1);
Gamma = linspace(omega/100,(numSeries+5)*omega,numB)';

eigenequation = WTypeeigenequation(Gamma,n1,n2,wavenumber,a,b,XLength);
               

if(plotsign==1)
	figure; plot(Gamma,eigenequation); axis([min(Gamma),max(Gamma),-10, 10]);
end;

%Matrix = [(1:numB)' Gamma eigenequation];save data/WType.dat Matrix -ascii -tabs;

StartIndex=2;
for bii =1:numSeries
	while(eigenequation(StartIndex)*eigenequation(StartIndex+1)>0||...
		abs(eigenequation(StartIndex)-eigenequation(StartIndex+1))>...
		abs(eigenequation(StartIndex-1)-eigenequation(StartIndex+2)))
		StartIndex=StartIndex+1;
	end
%	outputGamma(bii)  = fzero(@eigenequation3Layer,[Gamma(StartIndex) Gamma(StartIndex+1)],...
%		 optimset('TolX',1e-12,'Display','on'),n1,n2,wavenumber,a,XLength);

	relTol = 0.00000001;	DerX = 1e-8;	changeX=1;	MaxIterNum=100;IterNum=0;
	StartX=(Gamma(StartIndex)+Gamma(StartIndex+1))/2;
	while(abs(changeX/StartX)>relTol&&IterNum<MaxIterNum)
		F0=WTypeeigenequation(StartX,n1,n2,wavenumber,a,b,XLength);
		F1=WTypeeigenequation(StartX*(1+DerX),n1,n2,wavenumber,a,b,XLength);
        changeX = F0/(F0-F1)*(StartX*DerX);
		StartX=StartX+changeX;
		IterNum=IterNum+1;
	end;
	outputGamma(bii) =StartX;
	if(IterNum>MaxIterNum)	
		fprintf('exceed max Iternum\n'); stop;
	end;



	if(plotsign==2)
		fprintf('StartIndex = %d eigeneq = %f %f outputGamma = %f foundGamma=\n',StartIndex, eigenequation(StartIndex),...
			eigenequation(StartIndex+1),Gamma(StartIndex),outputGamma(bii));
	end;
	StartIndex=StartIndex+1;
end;
if(plotsign==2)
	figure; plot(1:numSeries,outputGamma); %axis([min(Gamma),max(Gamma),-10, 10]);
end;


