%
%
%   UndStdLeakyMode
%   Understand leaky modes: Slab waveguide revisited
%
%   Copyright (2008)
%   Computational Photonics Laboratory
%   University of Maryland Baltimore County
%   
%   By Jonathan Hu
%
function Neff = WTypePerturbation(n1,n2,a,b,wavenumber)


numPoints=100;
sq=inline('x*x','x');

v=wavenumber*a*sqrt(sq(n1)-sq(n2));
	Norne=0:1/numPoints:1;
	Norne=Norne(1:end-1);
	fout=zeros(numPoints,1)';
	for ii=1:numPoints	
		fout(ii)=OkamotoEq2_21(Norne(ii),v);
	end
%	plot(b,fout);
	for n=1:numPoints-1
		if(fout(n)*fout(n+1)<0)
			Nornezero = fzero(@OkamotoEq2_21,Norne(n),optimset('TolX',1e-10,'Display','on'),v);
		end
	end


ne=sqrt(Nornezero*(sq(n1)-sq(n2))+sq(n2));

sq=inline('x*x','x');
neff0=ne;
kx=wavenumber*sqrt(n1^2-ne^2);
alpha=wavenumber*sqrt(ne^2-n2^2);


Beta0=neff0*wavenumber;

tanterm=tan(kx*a);
%tanhterm=tanh(alpha*(b-a));
expterm = exp(-2*alpha*(b-a));
L=2*expterm*(kx*tanterm*i*kx+alpha^2)
M=(alpha/kx-kx/alpha)*(i+tanterm)+2+a*(alpha-i*kx)*(1+tanterm^2)-2i*tanterm...
    +(4*alpha*(b-a)-4+2i*a*kx*(1+tanterm^2)+4i*tanterm+4i*kx/alpha*tanterm*(b-a))*expterm;
deltaBeta=L/Beta0/M;
Neff=((Beta0+deltaBeta)/wavenumber);
