%
%
%   UndStdLeakyMode
%   Understand leaky modes: Slab waveguide revisited
%
%   Copyright (2008)
%   Computational Photonics Laboratory
%   University of Maryland Baltimore County
%   
%   By Jonathan Hu
%
function WTypeSteepestDecent(z,y2L,A,Ce,beta,n1,n2,a,b,wavenumber,plotsign)

    
sq=inline('x.*x','x');
lambda = 2*pi/wavenumber;
%    z=z(2:end);
gamma= sqrt(sq(n1*wavenumber)-beta.*beta);
A0=A(1)-gamma(1)*(A(2)-A(1))/(gamma(2)-gamma(1));
AP = (A(2)-A(1))/(gamma(2)-gamma(1));
Ce0=Ce(1)-gamma(1)*(Ce(2)-Ce(1))/(gamma(2)-gamma(1));
CeP= (Ce(2)-Ce(1))/(gamma(2)-gamma(1));
phy0=n1*2*pi/lambda*z;
phyPP=-z*(lambda/2/pi/n1);
Exz=A0*Ce0*exp(i*phy0).*sqrt(-2./phyPP).*((1-i)/sqrt(2)*sqrt(pi)/2);
Exz2st = AP*CeP.*exp(i*phy0).*(sqrt(-1./phyPP)).^3.*((1-i)/sqrt(2)).^3*sqrt(2*pi)/2;
[realne imagne] =WTypeLeaky(n1,n2,b/a,wavenumber,plotsign);
fprintf('result from SlabLeaky Neff = %f+ %f*i \n',realne,imagne);
y2Leaky = exp(i*(realne+i*imagne)*wavenumber.*z);
ExzNum=Exz+Exz2st;

figure;
semilogy(z(11:end)/lambda,sq(abs(ExzNum(11:end))),'g','LineWidth',2);
hold on;
semilogy(z/lambda,sq(abs(y2Leaky)),'g-.','LineWidth',2);
ExzNum(1:10)=0;
semilogy(z/lambda,sq(abs(y2Leaky+ExzNum)),'b','LineWidth',3);
semilogy(z/lambda,sq(abs(y2L)),'r--','LineWidth',3);   





