%
%
%   UndStdLeakyMode
%   Understand leaky modes: Slab waveguide revisited
%
%   Copyright (2008)
%   Computational Photonics Laboratory
%   University of Maryland Baltimore County
%   
%   By Jonathan Hu
%
function WTypeVaryb(width,A,Ce,beta,n1,n2,a,b,numSeries,...
        wavenumber,XLength,deltaX,ShinkXLengthFactor,plotsign)
sq=inline('x.*x','x');


format long;
n3=n1;


LossMatrix = [];
iiTotal =10;
for ii=2:iiTotal
  	bii=ii*a;
    if(b==bii)
        
    else
        b=bii;

        gamma = WTypeGetgammaSet(n1,n2,a,b,XLength,wavenumber,numSeries,plotsign);
        beta= sqrt(sq(n3*wavenumber)-gamma.*gamma);
        Ce=zeros(1,numSeries); 
        Ae=zeros(numSeries,1);
        for	nii=1:numSeries
            [A(nii) Ce(nii) Ae(nii)]=WTypeGetCouplingCoeff(width,n1,n2,a,b,...
                XLength,deltaX,wavenumber,beta(nii),ShinkXLengthFactor);
        end;
    end;
%    fprintf('WTypeLeaky\n');
    [EigenR EigenI]=WTypeLeaky(n1,n2,b/a,wavenumber,plotsign);
%    fprintf('WTypePerturbation\n');
    EigenIAppro=imag(WTypePerturbation(n1,n2,a,b,wavenumber));

%    fprintf('Analytical\n');
    [AAna CeAna StartPower neff]=WTypeRadiationMode(A,Ce,beta,n1,n2,...
                a,b,wavenumber);
    
	LossMatrix = [LossMatrix; b/a   EigenI EigenIAppro imag(neff)]

end;  
figure;
semilogy(LossMatrix(:,1),LossMatrix(:,2),'b','linewidth',2); 
hold on;
semilogy(LossMatrix(:,1),LossMatrix(:,3),'g-.','linewidth',2); 
semilogy(LossMatrix(:,1),LossMatrix(:,4),'r--','linewidth',2); 


xlabel('b/a');
ylabel('Im(n_{eff})');

 

 