%
%
%   UndStdLeakyMode
%   Understand leaky modes: Slab waveguide revisited
%
%   Copyright (2008)
%   Computational Photonics Laboratory
%   University of Maryland Baltimore County
%   
%   By Jonathan Hu
%
function ei = WTypeeigenequation(gamma,n1,n2,k0,a,b,XLength)
sq = inline('x.*x','x');
sigma = gamma;
rho = sqrt(gamma.*gamma+(sq(n2)-sq(n1))*sq(k0));
Ce=1;
De=Ce/2*exp(i*rho*a).*(cos(sigma*a)-i*sigma./rho.*sin(sigma*a));
%	Fe=conj(De);
Fe=Ce/2*exp(-i*rho*a).*(cos(sigma*a)+i*sigma./rho.*sin(sigma*a));
  
Ae=(1+rho./gamma)/2.*De.*exp(-i*(rho-gamma)*b)...
        +(1-rho./gamma)/2.*Fe.*exp(i*(rho+gamma)*b);
%    Be=conj(Ae);
Be=(1+rho./gamma)/2.*Fe.*exp(i*(rho-gamma)*b)...
        +(1-rho./gamma)/2.*De.*exp(-i*(rho+gamma)*b);
ei = [imag(Ae.*exp(-i*gamma*XLength)-Be.*exp(i*gamma*XLength)) ];
%	figure; plot(Gamma,[Ae.*exp(-i*gamma*XLength) Be.*exp(i*gamma*XLength)]); axis([min(Gamma),max(Gamma),-10, 10]);
